zoukankan      html  css  js  c++  java
  • POJ 1860 Bellman改判断正环

    Currency Exchange
    Time Limit: 1000MS   Memory Limit: 30000K
    Total Submissions: 26610   Accepted: 9842

    Description

    Several currency exchange points are working in our city. Let us suppose that each point specializes in two particular currencies and performs exchange operations only with these currencies. There can be several points specializing in the same pair of currencies. Each point has its own exchange rates, exchange rate of A to B is the quantity of B you get for 1A. Also each exchange point has some commission, the sum you have to pay for your exchange operation. Commission is always collected in source currency.
    For example, if you want to exchange 100 US Dollars into Russian Rubles at the exchange point, where the exchange rate is 29.75, and the commission is 0.39 you will get (100 - 0.39) * 29.75 = 2963.3975RUR.
    You surely know that there are N different currencies you can deal with in our city. Let us assign unique integer number from 1 to N to each currency. Then each exchange point can be described with 6 numbers: integer A and B - numbers of currencies it exchanges, and real RAB, CAB, RBA and CBA - exchange rates and commissions when exchanging A to B and B to A respectively.
    Nick has some money in currency S and wonders if he can somehow, after some exchange operations, increase his capital. Of course, he wants to have his money in currency S in the end. Help him to answer this difficult question. Nick must always have non-negative sum of money while making his operations.

    Input

    The first line of the input contains four numbers: N - the number of currencies, M - the number of exchange points, S - the number of currency Nick has and V - the quantity of currency units he has. The following M lines contain 6 numbers each - the description of the corresponding exchange point - in specified above order. Numbers are separated by one or more spaces. 1<=S<=N<=100, 1<=M<=100, V is real number, 0<=V<=103.
    For each point exchange rates and commissions are real, given with at most two digits after the decimal point, 10-2<=rate<=102, 0<=commission<=102.
    Let us call some sequence of the exchange operations simple if no exchange point is used more than once in this sequence. You may assume that ratio of the numeric values of the sums at the end and at the beginning of any simple sequence of the exchange operations will be less than 104.

    Output

    If Nick can increase his wealth, output YES, in other case output NO to the output file.

    Sample Input

    3 2 1 20.0
    1 2 1.00 1.00 1.00 1.00
    2 3 1.10 1.00 1.10 1.00
    

    Sample Output

    YES


    题意:

             有多种汇币,汇币之间可以交换,这需要手续费,当你用100A币交换B币时,A到B的汇率是29.75,手续费是0.39,那么你可以得到(100 - 0.39) * 29.75 = 2963.3975 B币。问s币的金额经过交换最终得到的s币金额数能否增加

    货币的交换是可以重复多次的,所以我们需要找出是否存在正权回路,且最后得到的s金额是增加的

    怎么找正权回路呢?(正权回路:在这一回路上,顶点的权值能不断增加即能一直进行松弛)


    分析:

    一种货币就是一个点

    一个“兑换点”就是图上两种货币之间的一个兑换方式,是双边,但A到B的汇率和手续费可能与B到A的汇率和手续费不同。

    唯一值得注意的是权值,当拥有货币A的数量为V时,A到A的权值为K,即没有兑换

    而A到B的权值为(V-Cab)*Rab

    本题是“求最大路径”,之所以被归类为“求最小路径”是因为本题题恰恰与bellman-Ford算法的松弛条件相反,求的是能无限松弛的最大正权路径,但是依然能够利用bellman-Ford的思想去解题。

    因此初始化dis(S)=V   而源点到其他点的距离(权值)初始化为无穷小(0),当s到其他某点的距离能不断变大时,说明存在最大路径;如果可以一直变大,说明存在正环。判断是否存在环路,用Bellman-Ford和spfa都可以。


    Bellman算法:

    #include<iostream>
    #include <cstdio>
    #include <cstring>
    using namespace std;
    const int maxn = 105;
    
    int n;  //货币种类
    int m;  //交换方式,路径
    int s;  //持有货币,原点
    double v; //本金
    
    int cnt,flag;
    double dis[maxn];
    
    struct edge{
    	int m1;
    	int m2;
    	double r;
    	double c;
    }ee[2*maxn];
    
    
    int main()
    {
    	int a,b;
    	double r1,r2,c1,c2;
        int check;
    	while(cin>>n>>m>>s>>v) //数据较水,多组数据都能过,题目单组数据
    	{
    		cnt=0;//每组数据边数初始化
    
    		for(int i=1;i<=m;i++)
    		{
    			cin>>a>>b>>r1>>c1>>r2>>c2;
    			ee[cnt].m1=a;
    			ee[cnt].m2=b;
    			ee[cnt].r=r1;
    			ee[cnt].c=c1;
    			cnt++;
    			ee[cnt].m1=b;
    			ee[cnt].m2=a;
    			ee[cnt].r=r2;
    			ee[cnt].c=c2;
    			cnt++;
    		}
    
                 memset(dis,0,sizeof(dis));//这里与bellman的目的刚好相反。初始化为源点到各点距离无穷小
    
    	     dis[s]=v; //初始化,这里的dis数组表示原币换成该号货币的总数(原点到该点的权值)
    
    	    for(int i=1;i<=n-1;i++)//n-1次松弛
               {
    		check=0;
    		for(int j=0;j<cnt;j++){
    			if(dis[ee[j].m2] < (dis[ee[j].m1] - ee[j].c) * ee[j].r)
    			{
    				dis[ee[j].m2] = (dis[ee[j].m1] - ee[j].c) * ee[j].r;
    				check=1;
    			}
    		}
    		if(check==0)
    			break;
    	}
    
       //此时已经松弛完毕,若还有松弛,则有正环
    	for(int i=0;i<cnt;i++){
    		if(dis[ee[i].m2] < (dis[ee[i].m1] - ee[i].c) * ee[i].r)
    			flag=1;}
    			if(flag)
    	    	cout<<"YES"<<endl;
    	    else
    	    	cout<<"NO"<<endl;
    	}
    	return 0;
    }
    


  • 相关阅读:
    算法提高---概率计算
    全排列
    算法提高 最小方差生成树
    【洛谷】P1040 加分二叉树
    SPAF模板
    Bellman-Ford算法(有向图)
    Floyd算法
    Dijkstra算法
    蓝桥杯算法提高 递推求值 【矩阵快速幂】
    【动态规划】数字分组I
  • 原文地址:https://www.cnblogs.com/zhangmingzhao/p/7256390.html
Copyright © 2011-2022 走看看